import { App } from '@kevisual/router';
import { sequelize } from './modules/sequelize.ts';
import { emitter } from './modules/event.ts';
export { sequelize };
export const app = new App();

export const runAppRouterFn = async (key: string, params: any) => {
  emitter.emit(`router.fn`, key, params);
};
const runListener = async (app: App) => {
  emitter.on('router.fn', (key, params) => {
    if (!app.router[key]) {
      console.error('router key not found:', key);
    } else {
      app.router[key](params);
    }
  });
};
runListener(app);

export const appendTo = (realApp: App) => {
  realApp.importApp(app);
  runListener(realApp);
};
